/**
	Fraga
	30/05/2018
**/
#include <stdio.h>
#include <stdlib.h>
#include "matrix.h"
#include "pnm.h"
#include "fill.h"

int main( int argc, char *argv[] )
{
	MATRIX *I;
	int i, j;
	byte *pimg;
	int p, x, y, v[5];

	if( argc != 2 ) {
		fprintf( stderr, "Args: nombre_imagen\n" );
		return 1;
	}

	I = read_pnm( argv[1] );	

	for( i=0; i<I->rows; i++ ) {
		pimg = (byte *)I->ptr[i];
		for( j=0; j<I->cols; j++ ) {
			if ( *pimg == 0 ) {
				x = j;
				y = i;
				goto SIGUE;
			}
			pimg++;
		}
	}
	fprintf( stderr, "ERROR: No hay objetos en la imagen!\n" );
	matrix_free( I );
	return 1;

	SIGUE:
	p = left ( I, x, y  ) ; 
	push( p, i );

	do_fill( I, v, 1 );

	for( i=v[INICIOY]; i<=v[FINY]; i++ ) {
		pimg = (byte *)I->ptr[i]+v[INICIOX];
		for( j=v[INICIOX]; j<=v[FINX]; j++ ) {
			if ( *pimg == 1 ) {
				*pimg = 200;
			}
			pimg++;
		}
	}

	I->type = 5;
    write_pnm( I, "relleno.pgm" );

	matrix_free( I );
	return 0;
}
