/**
	Fraga
	30/05/2018
**/
#include <stdio.h>
#include <stdlib.h>
#include "matrix.h"
#include "pnm.h"
#include "follow.h"

int main( int argc, char *argv[] )
{
	MATRIX *I;
	int i, j;
	byte *pimg;
	int x, y;

	if( argc != 2 ) {
		fprintf( stderr, "Args: nombre_imagen\n" );
		return 1;
	}

	I = read_pnm( argv[1] );	

	for( i=0; i<I->rows; i++ ) {
		pimg = (byte *)I->ptr[i];
		for( j=0; j<I->cols; j++ ) {
			if ( *pimg == 200 ) {
				x = j;
				y = i;
				goto SIGUE;
			}
			pimg++;
		}
	}
	fprintf( stderr, "ERROR: No hay un perímetro en la imagen!\n" );
	matrix_free( I );
	return 1;

	SIGUE:

	// Extraigo el perímetro que está ahora en 200
	// El fondo está a 255
	follow_perimeter( I, y, x, 200 );

	matrix_free( I );
	return 0;
}
